<template>
  <div
    ref="el">
    <slot />
    <slot
      v-if="marker"
      name="popup" />
  </div>
</template>

<script>
import { propsMarker } from './shared/props.js'

export const opts = propsMarker
</script>

<script setup>
import { useSlots, ref, onMounted, onBeforeUnmount, provide, inject } from 'vue'
import { watchInstance } from './shared/watch.js'
import { setOptions } from './shared/options.js'
import { eventsMarkerEmit, eventsMarker } from './shared/events.js'
import { defineHandlers, removeHandlers } from '@/shared/events.js'
import { Marker } from 'maplibre-gl'

// inject and dom check
const map = inject('map')
const slots = useSlots()
const emit = defineEmits(eventsMarkerEmit)
const hasChildren = slots.default ? slots.default().length >= 1 : false

// props
const props = defineProps(opts)

// base options
const options = setOptions(props)
delete options.lngLat

// data
const el = ref(null)
const marker = ref(null)

// events handler
let handlers = {}
const click = e => emit('click', marker.value)

// wait for DOM to add to map
onMounted(() => {
  if (hasChildren) options.element = el.value

  // create marker
  marker.value = new Marker(options)

  // add to map
  marker.value
    .setLngLat(props.lngLat)
    .addTo(map.value)

  emit('mounted', marker.value)

  // watch
  watchInstance(marker, props)

  // events
  const markerEl = marker.value.getElement()
  markerEl.addEventListener('click', click)
  handlers = defineHandlers(eventsMarker, marker)
})

// clean
onBeforeUnmount(() => {
  const markerEl = marker.value.getElement()
  markerEl.removeEventListener('click', click)
  removeHandlers(handlers, marker)
  marker.value.remove()
})

// expose to children
provide('marker', marker)

// expose to parent
defineExpose({
  marker
})
</script>
